/* xkblayout.c generated by valac 0.24.0, the Vala compiler
 * generated from xkblayout.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2013 Red Hat, Inc.
 * Copyright(c) 2013 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright(c) 2013 Takao Fujiwara <tfujiwar@redhat.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <ibus.h>
#include <gobject/gvaluecollector.h>


#define TYPE_XKB_LAYOUT (xkb_layout_get_type ())
#define XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_XKB_LAYOUT, XKBLayout))
#define XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_XKB_LAYOUT, XKBLayoutClass))
#define IS_XKB_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_XKB_LAYOUT))
#define IS_XKB_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_XKB_LAYOUT))
#define XKB_LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_XKB_LAYOUT, XKBLayoutClass))

typedef struct _XKBLayout XKBLayout;
typedef struct _XKBLayoutClass XKBLayoutClass;
typedef struct _XKBLayoutPrivate XKBLayoutPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecXKBLayout ParamSpecXKBLayout;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _XKBLayout {
	GTypeInstance parent_instance;
	volatile int ref_count;
	XKBLayoutPrivate * priv;
};

struct _XKBLayoutClass {
	GTypeClass parent_class;
	void (*finalize) (XKBLayout *self);
};

struct _XKBLayoutPrivate {
	gchar* m_xkb_command;
	GSettings* m_settings_general;
	gchar** m_xkb_latin_layouts;
	gint m_xkb_latin_layouts_length1;
	gint _m_xkb_latin_layouts_size_;
	GPid m_xkb_pid;
	GPid m_xmodmap_pid;
	gchar* m_xmodmap_command;
	gboolean m_use_xmodmap;
	gchar** m_xmodmap_known_files;
	gint m_xmodmap_known_files_length1;
	gint _m_xmodmap_known_files_size_;
	gchar* m_default_layout;
	gchar* m_default_variant;
	gchar* m_default_option;
};

struct _ParamSpecXKBLayout {
	GParamSpec parent_instance;
};


static gpointer xkb_layout_parent_class = NULL;

gpointer xkb_layout_ref (gpointer instance);
void xkb_layout_unref (gpointer instance);
GParamSpec* param_spec_xkb_layout (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_xkb_layout (GValue* value, gpointer v_object);
void value_take_xkb_layout (GValue* value, gpointer v_object);
gpointer value_get_xkb_layout (const GValue* value);
GType xkb_layout_get_type (void) G_GNUC_CONST;
#define XKB_LAYOUT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_XKB_LAYOUT, XKBLayoutPrivate))
enum  {
	XKB_LAYOUT_DUMMY_PROPERTY
};
XKBLayout* xkb_layout_new (void);
XKBLayout* xkb_layout_construct (GType object_type);
static void _vala_array_add37 (gchar*** array, int* length, int* size, gchar* value);
static gchar* xkb_layout_get_output_from_cmdline (XKBLayout* self, const gchar* arg, const gchar* element);
static void _vala_array_add38 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add39 (gchar*** array, int* length, int* size, gchar* value);
static void xkb_layout_set_layout_cb (XKBLayout* self, GPid pid, gint status);
void xkb_layout_set_xmodmap (XKBLayout* self);
static void xkb_layout_set_xmodmap_cb (XKBLayout* self, GPid pid, gint status);
static gchar* xkb_layout_get_fullpath (XKBLayout* self, const gchar* command);
static gchar** xkb_layout_get_xkb_group_layout (XKBLayout* self, const gchar* layout, const gchar* variant, gint layouts_max_length, int* result_length1);
gchar** xkb_layout_get_variant_from_layout (XKBLayout* self, const gchar* layout, int* result_length1);
gchar** xkb_layout_get_option_from_layout (XKBLayout* self, const gchar* layout, int* result_length1);
gchar* xkb_layout_get_layout (XKBLayout* self);
gchar* xkb_layout_get_variant (XKBLayout* self);
gchar* xkb_layout_get_option (XKBLayout* self);
gint* xkb_layout_set_layout (XKBLayout* self, IBusEngineDesc* engine, gboolean use_group_layout, int* result_length1);
static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle);
static void _vala_array_add40 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add41 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add42 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add43 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add44 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add45 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add46 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add47 (gchar*** array, int* length, int* size, gchar* value);
static void _xkb_layout_set_layout_cb_gchild_watch_func (GPid pid, gint status, gpointer self);
static void _xkb_layout_set_xmodmap_cb_gchild_watch_func (GPid pid, gint status, gpointer self);
void xkb_layout_reset_layout (XKBLayout* self);
static void xkb_layout_finalize (XKBLayout* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void _vala_array_add37 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


XKBLayout* xkb_layout_construct (GType object_type) {
	XKBLayout* self = NULL;
	GSettings* _tmp0_ = NULL;
	GVariant* value = NULL;
	GSettings* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	gboolean _tmp16_ = FALSE;
	self = (XKBLayout*) g_type_create_instance (object_type);
	_tmp0_ = g_settings_new ("org.freedesktop.ibus.general");
	_g_object_unref0 (self->priv->m_settings_general);
	self->priv->m_settings_general = _tmp0_;
	_tmp1_ = self->priv->m_settings_general;
	_tmp2_ = g_settings_get_value (_tmp1_, "xkb-latin-layouts");
	value = _tmp2_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_ = FALSE;
				GVariant* _tmp6_ = NULL;
				gchar** _tmp10_ = NULL;
				gint _tmp10__length1 = 0;
				GVariant* _tmp11_ = NULL;
				gint _tmp12_ = 0;
				GVariant* _tmp13_ = NULL;
				GVariant* _tmp14_ = NULL;
				gchar* _tmp15_ = NULL;
				if (!_tmp3_) {
					gint _tmp4_ = 0;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp6_ = value;
				if (_tmp6_ != NULL) {
					gint _tmp7_ = 0;
					GVariant* _tmp8_ = NULL;
					gsize _tmp9_ = 0UL;
					_tmp7_ = i;
					_tmp8_ = value;
					_tmp9_ = g_variant_n_children (_tmp8_);
					_tmp5_ = ((gsize) _tmp7_) < _tmp9_;
				} else {
					_tmp5_ = FALSE;
				}
				if (!_tmp5_) {
					break;
				}
				_tmp10_ = self->priv->m_xkb_latin_layouts;
				_tmp10__length1 = self->priv->m_xkb_latin_layouts_length1;
				_tmp11_ = value;
				_tmp12_ = i;
				_tmp13_ = g_variant_get_child_value (_tmp11_, (gsize) _tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = g_variant_dup_string (_tmp14_, NULL);
				_vala_array_add37 (&self->priv->m_xkb_latin_layouts, &self->priv->m_xkb_latin_layouts_length1, &self->priv->_m_xkb_latin_layouts_size_, _tmp15_);
				_g_variant_unref0 (_tmp14_);
			}
		}
	}
	_tmp16_ = self->priv->m_use_xmodmap;
	if (_tmp16_) {
		GSettings* _tmp17_ = NULL;
		gboolean _tmp18_ = FALSE;
		_tmp17_ = self->priv->m_settings_general;
		_tmp18_ = g_settings_get_boolean (_tmp17_, "use-xmodmap");
		self->priv->m_use_xmodmap = _tmp18_;
	}
	_g_variant_unref0 (value);
	return self;
}


XKBLayout* xkb_layout_new (void) {
	return xkb_layout_construct (TYPE_XKB_LAYOUT);
}


static void _vala_array_add38 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add39 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_ = 0L;
	glong _tmp16_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	gchar* _tmp21_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	g_return_val_if_fail (_tmp8_, NULL);
	_tmp13_ = end;
	if (_tmp13_ >= ((glong) 0)) {
		glong _tmp14_ = 0L;
		glong _tmp15_ = 0L;
		_tmp14_ = end;
		_tmp15_ = string_length;
		_tmp12_ = _tmp14_ <= _tmp15_;
	} else {
		_tmp12_ = FALSE;
	}
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp16_ = start;
	_tmp17_ = end;
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	_tmp20_ = start;
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
	result = _tmp21_;
	return result;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static gchar* xkb_layout_get_output_from_cmdline (XKBLayout* self, const gchar* arg, const gchar* element) {
	gchar* result = NULL;
	gchar** exec_command = NULL;
	gchar** _tmp0_ = NULL;
	gint exec_command_length1 = 0;
	gint _exec_command_size_ = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* standard_output = NULL;
	gchar* standard_error = NULL;
	gint exit_status = 0;
	gchar* retval = NULL;
	gchar* _tmp7_ = NULL;
	gint _tmp15_ = 0;
	const gchar* _tmp19_ = NULL;
	const gchar* _tmp21_ = NULL;
	gchar** _tmp22_ = NULL;
	gchar** _tmp23_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (arg != NULL, NULL);
	g_return_val_if_fail (element != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	exec_command = _tmp0_;
	exec_command_length1 = 0;
	_exec_command_size_ = exec_command_length1;
	_tmp1_ = exec_command;
	_tmp1__length1 = exec_command_length1;
	_tmp2_ = self->priv->m_xkb_command;
	_tmp3_ = g_strdup (_tmp2_);
	_vala_array_add38 (&exec_command, &exec_command_length1, &_exec_command_size_, _tmp3_);
	_tmp4_ = exec_command;
	_tmp4__length1 = exec_command_length1;
	_tmp5_ = arg;
	_tmp6_ = g_strdup (_tmp5_);
	_vala_array_add39 (&exec_command, &exec_command_length1, &_exec_command_size_, _tmp6_);
	standard_output = NULL;
	standard_error = NULL;
	exit_status = 0;
	_tmp7_ = g_strdup ("");
	retval = _tmp7_;
	{
		gchar** _tmp8_ = NULL;
		gint _tmp8__length1 = 0;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gint _tmp11_ = 0;
		_tmp8_ = exec_command;
		_tmp8__length1 = exec_command_length1;
		g_spawn_sync (NULL, _tmp8_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp9_, &_tmp10_, &_tmp11_, &_inner_error_);
		_g_free0 (standard_output);
		standard_output = _tmp9_;
		_g_free0 (standard_error);
		standard_error = _tmp10_;
		exit_status = _tmp11_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_SPAWN_ERROR) {
				goto __catch6_g_spawn_error;
			}
			_g_free0 (retval);
			_g_free0 (standard_error);
			_g_free0 (standard_output);
			exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	goto __finally6;
	__catch6_g_spawn_error:
	{
		GError* err = NULL;
		FILE* _tmp12_ = NULL;
		GError* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp12_ = stderr;
		_tmp13_ = err;
		_tmp14_ = _tmp13_->message;
		fprintf (_tmp12_, "IBUS_ERROR: %s\n", _tmp14_);
		_g_error_free0 (err);
	}
	__finally6:
	if (_inner_error_ != NULL) {
		_g_free0 (retval);
		_g_free0 (standard_error);
		_g_free0 (standard_output);
		exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp15_ = exit_status;
	if (_tmp15_ != 0) {
		const gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		FILE* _tmp18_ = NULL;
		_tmp17_ = standard_error;
		_tmp16_ = _tmp17_;
		if (_tmp16_ == NULL) {
			_tmp16_ = "";
		}
		_tmp18_ = stderr;
		fprintf (_tmp18_, "IBUS_ERROR: %s\n", _tmp16_);
	}
	_tmp19_ = standard_output;
	if (_tmp19_ == NULL) {
		gchar* _tmp20_ = NULL;
		_tmp20_ = g_strdup ("");
		result = _tmp20_;
		_g_free0 (retval);
		_g_free0 (standard_error);
		_g_free0 (standard_output);
		exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp21_ = standard_output;
	_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, "\n", 0);
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
		line_collection = _tmp23_;
		line_collection_length1 = _vala_array_length (_tmp22_);
		for (line_it = 0; line_it < _vala_array_length (_tmp22_); line_it = line_it + 1) {
			gchar* _tmp24_ = NULL;
			gchar* line = NULL;
			_tmp24_ = g_strdup (line_collection[line_it]);
			line = _tmp24_;
			{
				gboolean _tmp25_ = FALSE;
				const gchar* _tmp26_ = NULL;
				gint _tmp27_ = 0;
				gint _tmp28_ = 0;
				const gchar* _tmp29_ = NULL;
				gint _tmp30_ = 0;
				gint _tmp31_ = 0;
				_tmp26_ = element;
				_tmp27_ = strlen (_tmp26_);
				_tmp28_ = _tmp27_;
				_tmp29_ = line;
				_tmp30_ = strlen (_tmp29_);
				_tmp31_ = _tmp30_;
				if (_tmp28_ <= _tmp31_) {
					const gchar* _tmp32_ = NULL;
					const gchar* _tmp33_ = NULL;
					gint _tmp34_ = 0;
					gint _tmp35_ = 0;
					gchar* _tmp36_ = NULL;
					gchar* _tmp37_ = NULL;
					const gchar* _tmp38_ = NULL;
					_tmp32_ = line;
					_tmp33_ = element;
					_tmp34_ = strlen (_tmp33_);
					_tmp35_ = _tmp34_;
					_tmp36_ = string_slice (_tmp32_, (glong) 0, (glong) _tmp35_);
					_tmp37_ = _tmp36_;
					_tmp38_ = element;
					_tmp25_ = g_strcmp0 (_tmp37_, _tmp38_) == 0;
					_g_free0 (_tmp37_);
				} else {
					_tmp25_ = FALSE;
				}
				if (_tmp25_) {
					const gchar* _tmp39_ = NULL;
					const gchar* _tmp40_ = NULL;
					gint _tmp41_ = 0;
					gint _tmp42_ = 0;
					const gchar* _tmp43_ = NULL;
					gint _tmp44_ = 0;
					gint _tmp45_ = 0;
					gchar* _tmp46_ = NULL;
					const gchar* _tmp47_ = NULL;
					_tmp39_ = line;
					_tmp40_ = element;
					_tmp41_ = strlen (_tmp40_);
					_tmp42_ = _tmp41_;
					_tmp43_ = line;
					_tmp44_ = strlen (_tmp43_);
					_tmp45_ = _tmp44_;
					_tmp46_ = string_slice (_tmp39_, (glong) _tmp42_, (glong) _tmp45_);
					_g_free0 (retval);
					retval = _tmp46_;
					_tmp47_ = retval;
					if (_tmp47_ == NULL) {
						gchar* _tmp48_ = NULL;
						_tmp48_ = g_strdup ("");
						_g_free0 (retval);
						retval = _tmp48_;
					} else {
						const gchar* _tmp49_ = NULL;
						gchar* _tmp50_ = NULL;
						_tmp49_ = retval;
						_tmp50_ = string_strip (_tmp49_);
						_g_free0 (retval);
						retval = _tmp50_;
					}
				}
				_g_free0 (line);
			}
		}
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	result = retval;
	_g_free0 (standard_error);
	_g_free0 (standard_output);
	exec_command = (_vala_array_free (exec_command, exec_command_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static void xkb_layout_set_layout_cb (XKBLayout* self, GPid pid, gint status) {
	GPid _tmp0_ = 0;
	GPid _tmp1_ = 0;
	GPid _tmp3_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_xkb_pid;
	_tmp1_ = pid;
	if (_tmp0_ != _tmp1_) {
		FILE* _tmp2_ = NULL;
		_tmp2_ = stderr;
		fprintf (_tmp2_, "IBUS_ERROR: set_layout_cb has another pid\n");
		return;
	}
	_tmp3_ = self->priv->m_xkb_pid;
	g_spawn_close_pid (_tmp3_);
	self->priv->m_xkb_pid = (GPid) (-1);
	xkb_layout_set_xmodmap (self);
}


static void xkb_layout_set_xmodmap_cb (XKBLayout* self, GPid pid, gint status) {
	GPid _tmp0_ = 0;
	GPid _tmp1_ = 0;
	GPid _tmp3_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_xmodmap_pid;
	_tmp1_ = pid;
	if (_tmp0_ != _tmp1_) {
		FILE* _tmp2_ = NULL;
		_tmp2_ = stderr;
		fprintf (_tmp2_, "IBUS_ERROR: set_xmodmap_cb has another pid\n");
		return;
	}
	_tmp3_ = self->priv->m_xmodmap_pid;
	g_spawn_close_pid (_tmp3_);
	self->priv->m_xmodmap_pid = (GPid) (-1);
}


static gchar* xkb_layout_get_fullpath (XKBLayout* self, const gchar* command) {
	gchar* result = NULL;
	gchar* envpath = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gchar* _tmp11_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (command != NULL, NULL);
	_tmp0_ = g_getenv ("PATH");
	_tmp1_ = g_strdup (_tmp0_);
	envpath = _tmp1_;
	_tmp2_ = envpath;
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ":", 0);
	{
		gchar** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
		dir_collection = _tmp4_;
		dir_collection_length1 = _vala_array_length (_tmp3_);
		for (dir_it = 0; dir_it < _vala_array_length (_tmp3_); dir_it = dir_it + 1) {
			gchar* _tmp5_ = NULL;
			gchar* dir = NULL;
			_tmp5_ = g_strdup (dir_collection[dir_it]);
			dir = _tmp5_;
			{
				gchar* filepath = NULL;
				const gchar* _tmp6_ = NULL;
				const gchar* _tmp7_ = NULL;
				gchar* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
				_tmp6_ = dir;
				_tmp7_ = command;
				_tmp8_ = g_build_filename (_tmp6_, _tmp7_, NULL);
				filepath = _tmp8_;
				_tmp9_ = filepath;
				_tmp10_ = g_file_test (_tmp9_, G_FILE_TEST_EXISTS);
				if (_tmp10_) {
					result = filepath;
					_g_free0 (dir);
					dir_collection = (_vala_array_free (dir_collection, dir_collection_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (envpath);
					return result;
				}
				_g_free0 (filepath);
				_g_free0 (dir);
			}
		}
		dir_collection = (_vala_array_free (dir_collection, dir_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp11_ = g_strdup ("");
	result = _tmp11_;
	_g_free0 (envpath);
	return result;
}


static gchar** xkb_layout_get_xkb_group_layout (XKBLayout* self, const gchar* layout, const gchar* variant, gint layouts_max_length, int* result_length1) {
	gchar** result = NULL;
	gint group_id = 0;
	gint i = 0;
	gchar** layouts = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint layouts_length1 = 0;
	gint _layouts_size_ = 0;
	gchar** variants = NULL;
	const gchar* _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gchar** _tmp5_ = NULL;
	gint variants_length1 = 0;
	gint _variants_size_ = 0;
	gchar* group_layouts = NULL;
	gchar* _tmp6_ = NULL;
	gchar* group_variants = NULL;
	gchar* _tmp7_ = NULL;
	gboolean has_variant = FALSE;
	gboolean include_keymap = FALSE;
	const gchar* _tmp60_ = NULL;
	gboolean _tmp61_ = FALSE;
	gboolean _tmp69_ = FALSE;
	const gchar* _tmp70_ = NULL;
	gchar* _tmp71_ = NULL;
	const gchar* _tmp72_ = NULL;
	gchar* _tmp73_ = NULL;
	gint _tmp74_ = 0;
	gchar* _tmp75_ = NULL;
	gchar** _tmp76_ = NULL;
	gchar** _tmp77_ = NULL;
	gint _tmp77__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (layout != NULL, NULL);
	g_return_val_if_fail (variant != NULL, NULL);
	group_id = 0;
	i = 0;
	_tmp0_ = self->priv->m_default_layout;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ",", 0);
	layouts = _tmp2_;
	layouts_length1 = _vala_array_length (_tmp1_);
	_layouts_size_ = layouts_length1;
	_tmp3_ = self->priv->m_default_variant;
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, ",", 0);
	variants = _tmp5_;
	variants_length1 = _vala_array_length (_tmp4_);
	_variants_size_ = variants_length1;
	_tmp6_ = g_strdup ("");
	group_layouts = _tmp6_;
	_tmp7_ = g_strdup ("");
	group_variants = _tmp7_;
	has_variant = FALSE;
	include_keymap = FALSE;
	{
		gboolean _tmp8_ = FALSE;
		i = 0;
		_tmp8_ = TRUE;
		while (TRUE) {
			gint _tmp10_ = 0;
			gchar** _tmp11_ = NULL;
			gint _tmp11__length1 = 0;
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			gint _tmp24_ = 0;
			gchar** _tmp25_ = NULL;
			gint _tmp25__length1 = 0;
			gboolean _tmp37_ = FALSE;
			const gchar* _tmp38_ = NULL;
			gchar** _tmp39_ = NULL;
			gint _tmp39__length1 = 0;
			gint _tmp40_ = 0;
			const gchar* _tmp41_ = NULL;
			gchar** _tmp47_ = NULL;
			gint _tmp47__length1 = 0;
			gint _tmp48_ = 0;
			const gchar* _tmp49_ = NULL;
			gint _tmp50_ = 0;
			if (!_tmp8_) {
				gint _tmp9_ = 0;
				_tmp9_ = i;
				i = _tmp9_ + 1;
			}
			_tmp8_ = FALSE;
			_tmp10_ = i;
			_tmp11_ = layouts;
			_tmp11__length1 = layouts_length1;
			if (!(_tmp10_ < _tmp11__length1)) {
				break;
			}
			_tmp12_ = i;
			_tmp13_ = layouts_max_length;
			if (_tmp12_ >= (_tmp13_ - 1)) {
				break;
			}
			_tmp14_ = i;
			if (_tmp14_ == 0) {
				gchar** _tmp15_ = NULL;
				gint _tmp15__length1 = 0;
				gint _tmp16_ = 0;
				const gchar* _tmp17_ = NULL;
				gchar* _tmp18_ = NULL;
				_tmp15_ = layouts;
				_tmp15__length1 = layouts_length1;
				_tmp16_ = i;
				_tmp17_ = _tmp15_[_tmp16_];
				_tmp18_ = g_strdup (_tmp17_);
				_g_free0 (group_layouts);
				group_layouts = _tmp18_;
			} else {
				const gchar* _tmp19_ = NULL;
				gchar** _tmp20_ = NULL;
				gint _tmp20__length1 = 0;
				gint _tmp21_ = 0;
				const gchar* _tmp22_ = NULL;
				gchar* _tmp23_ = NULL;
				_tmp19_ = group_layouts;
				_tmp20_ = layouts;
				_tmp20__length1 = layouts_length1;
				_tmp21_ = i;
				_tmp22_ = _tmp20_[_tmp21_];
				_tmp23_ = g_strdup_printf ("%s,%s", _tmp19_, _tmp22_);
				_g_free0 (group_layouts);
				group_layouts = _tmp23_;
			}
			_tmp24_ = i;
			_tmp25_ = variants;
			_tmp25__length1 = variants_length1;
			if (_tmp24_ >= _tmp25__length1) {
				gint _tmp26_ = 0;
				gboolean _tmp30_ = FALSE;
				const gchar* _tmp31_ = NULL;
				gchar** _tmp32_ = NULL;
				gint _tmp32__length1 = 0;
				gint _tmp33_ = 0;
				const gchar* _tmp34_ = NULL;
				_tmp26_ = i;
				if (_tmp26_ == 0) {
					gchar* _tmp27_ = NULL;
					_tmp27_ = g_strdup ("");
					_g_free0 (group_variants);
					group_variants = _tmp27_;
				} else {
					const gchar* _tmp28_ = NULL;
					gchar* _tmp29_ = NULL;
					_tmp28_ = group_variants;
					_tmp29_ = g_strconcat (_tmp28_, ",", NULL);
					_g_free0 (group_variants);
					group_variants = _tmp29_;
				}
				_tmp31_ = layout;
				_tmp32_ = layouts;
				_tmp32__length1 = layouts_length1;
				_tmp33_ = i;
				_tmp34_ = _tmp32_[_tmp33_];
				if (g_strcmp0 (_tmp31_, _tmp34_) == 0) {
					const gchar* _tmp35_ = NULL;
					_tmp35_ = variant;
					_tmp30_ = g_strcmp0 (_tmp35_, "") == 0;
				} else {
					_tmp30_ = FALSE;
				}
				if (_tmp30_) {
					gint _tmp36_ = 0;
					include_keymap = TRUE;
					_tmp36_ = i;
					group_id = _tmp36_;
				}
				continue;
			}
			_tmp38_ = layout;
			_tmp39_ = layouts;
			_tmp39__length1 = layouts_length1;
			_tmp40_ = i;
			_tmp41_ = _tmp39_[_tmp40_];
			if (g_strcmp0 (_tmp38_, _tmp41_) == 0) {
				const gchar* _tmp42_ = NULL;
				gchar** _tmp43_ = NULL;
				gint _tmp43__length1 = 0;
				gint _tmp44_ = 0;
				const gchar* _tmp45_ = NULL;
				_tmp42_ = variant;
				_tmp43_ = variants;
				_tmp43__length1 = variants_length1;
				_tmp44_ = i;
				_tmp45_ = _tmp43_[_tmp44_];
				_tmp37_ = g_strcmp0 (_tmp42_, _tmp45_) == 0;
			} else {
				_tmp37_ = FALSE;
			}
			if (_tmp37_) {
				gint _tmp46_ = 0;
				include_keymap = TRUE;
				_tmp46_ = i;
				group_id = _tmp46_;
			}
			_tmp47_ = variants;
			_tmp47__length1 = variants_length1;
			_tmp48_ = i;
			_tmp49_ = _tmp47_[_tmp48_];
			if (g_strcmp0 (_tmp49_, "") != 0) {
				has_variant = TRUE;
			}
			_tmp50_ = i;
			if (_tmp50_ == 0) {
				gchar** _tmp51_ = NULL;
				gint _tmp51__length1 = 0;
				gint _tmp52_ = 0;
				const gchar* _tmp53_ = NULL;
				gchar* _tmp54_ = NULL;
				_tmp51_ = variants;
				_tmp51__length1 = variants_length1;
				_tmp52_ = i;
				_tmp53_ = _tmp51_[_tmp52_];
				_tmp54_ = g_strdup (_tmp53_);
				_g_free0 (group_variants);
				group_variants = _tmp54_;
			} else {
				const gchar* _tmp55_ = NULL;
				gchar** _tmp56_ = NULL;
				gint _tmp56__length1 = 0;
				gint _tmp57_ = 0;
				const gchar* _tmp58_ = NULL;
				gchar* _tmp59_ = NULL;
				_tmp55_ = group_variants;
				_tmp56_ = variants;
				_tmp56__length1 = variants_length1;
				_tmp57_ = i;
				_tmp58_ = _tmp56_[_tmp57_];
				_tmp59_ = g_strdup_printf ("%s,%s", _tmp55_, _tmp58_);
				_g_free0 (group_variants);
				group_variants = _tmp59_;
			}
		}
	}
	_tmp60_ = variant;
	if (g_strcmp0 (_tmp60_, "") != 0) {
		has_variant = TRUE;
	}
	_tmp61_ = include_keymap;
	if (!_tmp61_) {
		const gchar* _tmp62_ = NULL;
		const gchar* _tmp63_ = NULL;
		gchar* _tmp64_ = NULL;
		const gchar* _tmp65_ = NULL;
		const gchar* _tmp66_ = NULL;
		gchar* _tmp67_ = NULL;
		gint _tmp68_ = 0;
		_tmp62_ = group_layouts;
		_tmp63_ = layout;
		_tmp64_ = g_strdup_printf ("%s,%s", _tmp62_, _tmp63_);
		_g_free0 (group_layouts);
		group_layouts = _tmp64_;
		_tmp65_ = group_variants;
		_tmp66_ = variant;
		_tmp67_ = g_strdup_printf ("%s,%s", _tmp65_, _tmp66_);
		_g_free0 (group_variants);
		group_variants = _tmp67_;
		_tmp68_ = i;
		group_id = _tmp68_;
	}
	_tmp69_ = has_variant;
	if (!_tmp69_) {
		_g_free0 (group_variants);
		group_variants = NULL;
	}
	_tmp70_ = group_layouts;
	_tmp71_ = g_strdup (_tmp70_);
	_tmp72_ = group_variants;
	_tmp73_ = g_strdup (_tmp72_);
	_tmp74_ = group_id;
	_tmp75_ = g_strdup_printf ("%i", _tmp74_);
	_tmp76_ = g_new0 (gchar*, 3 + 1);
	_tmp76_[0] = _tmp71_;
	_tmp76_[1] = _tmp73_;
	_tmp76_[2] = _tmp75_;
	_tmp77_ = _tmp76_;
	_tmp77__length1 = 3;
	if (result_length1) {
		*result_length1 = _tmp77__length1;
	}
	result = _tmp77_;
	_g_free0 (group_variants);
	_g_free0 (group_layouts);
	variants = (_vala_array_free (variants, variants_length1, (GDestroyNotify) g_free), NULL);
	layouts = (_vala_array_free (layouts, layouts_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static gint string_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = start_index;
	_tmp1_ = needle;
	_tmp2_ = strstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_ = NULL;
		_tmp4_ = _result_;
		result = (gint) (_tmp4_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


gchar** xkb_layout_get_variant_from_layout (XKBLayout* self, const gchar* layout, int* result_length1) {
	gchar** result = NULL;
	gint left_bracket = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint right_bracket = 0;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_ = 0;
	const gchar* _tmp27_ = NULL;
	gchar* _tmp28_ = NULL;
	gchar* _tmp29_ = NULL;
	gchar** _tmp30_ = NULL;
	gchar** _tmp31_ = NULL;
	gint _tmp31__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (layout != NULL, NULL);
	_tmp0_ = layout;
	_tmp1_ = string_index_of (_tmp0_, "(", 0);
	left_bracket = _tmp1_;
	_tmp2_ = layout;
	_tmp3_ = string_index_of (_tmp2_, ")", 0);
	right_bracket = _tmp3_;
	_tmp5_ = left_bracket;
	if (_tmp5_ >= 0) {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		_tmp6_ = right_bracket;
		_tmp7_ = left_bracket;
		_tmp4_ = _tmp6_ > _tmp7_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		const gchar* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		const gchar* _tmp14_ = NULL;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		gint _tmp21_ = 0;
		gint _tmp22_ = 0;
		gchar* _tmp23_ = NULL;
		gchar** _tmp24_ = NULL;
		gchar** _tmp25_ = NULL;
		gint _tmp25__length1 = 0;
		gchar** _tmp26_ = NULL;
		gint _tmp26__length1 = 0;
		_tmp8_ = layout;
		_tmp9_ = left_bracket;
		_tmp10_ = string_slice (_tmp8_, (glong) 0, (glong) _tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = layout;
		_tmp13_ = right_bracket;
		_tmp14_ = layout;
		_tmp15_ = strlen (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = string_slice (_tmp12_, (glong) (_tmp13_ + 1), (glong) _tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_strconcat (_tmp11_, _tmp18_, NULL);
		_tmp20_ = layout;
		_tmp21_ = left_bracket;
		_tmp22_ = right_bracket;
		_tmp23_ = string_slice (_tmp20_, (glong) (_tmp21_ + 1), (glong) _tmp22_);
		_tmp24_ = g_new0 (gchar*, 2 + 1);
		_tmp24_[0] = _tmp19_;
		_tmp24_[1] = _tmp23_;
		_tmp25_ = _tmp24_;
		_tmp25__length1 = 2;
		_g_free0 (_tmp18_);
		_g_free0 (_tmp11_);
		_tmp26_ = _tmp25_;
		_tmp26__length1 = _tmp25__length1;
		if (result_length1) {
			*result_length1 = _tmp26__length1;
		}
		result = _tmp26_;
		return result;
	}
	_tmp27_ = layout;
	_tmp28_ = g_strdup (_tmp27_);
	_tmp29_ = g_strdup ("default");
	_tmp30_ = g_new0 (gchar*, 2 + 1);
	_tmp30_[0] = _tmp28_;
	_tmp30_[1] = _tmp29_;
	_tmp31_ = _tmp30_;
	_tmp31__length1 = 2;
	if (result_length1) {
		*result_length1 = _tmp31__length1;
	}
	result = _tmp31_;
	return result;
}


gchar** xkb_layout_get_option_from_layout (XKBLayout* self, const gchar* layout, int* result_length1) {
	gchar** result = NULL;
	gint left_bracket = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint right_bracket = 0;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_ = 0;
	const gchar* _tmp27_ = NULL;
	gchar* _tmp28_ = NULL;
	gchar* _tmp29_ = NULL;
	gchar** _tmp30_ = NULL;
	gchar** _tmp31_ = NULL;
	gint _tmp31__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (layout != NULL, NULL);
	_tmp0_ = layout;
	_tmp1_ = string_index_of (_tmp0_, "[", 0);
	left_bracket = _tmp1_;
	_tmp2_ = layout;
	_tmp3_ = string_index_of (_tmp2_, "]", 0);
	right_bracket = _tmp3_;
	_tmp5_ = left_bracket;
	if (_tmp5_ >= 0) {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		_tmp6_ = right_bracket;
		_tmp7_ = left_bracket;
		_tmp4_ = _tmp6_ > _tmp7_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		const gchar* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		const gchar* _tmp14_ = NULL;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		gint _tmp21_ = 0;
		gint _tmp22_ = 0;
		gchar* _tmp23_ = NULL;
		gchar** _tmp24_ = NULL;
		gchar** _tmp25_ = NULL;
		gint _tmp25__length1 = 0;
		gchar** _tmp26_ = NULL;
		gint _tmp26__length1 = 0;
		_tmp8_ = layout;
		_tmp9_ = left_bracket;
		_tmp10_ = string_slice (_tmp8_, (glong) 0, (glong) _tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = layout;
		_tmp13_ = right_bracket;
		_tmp14_ = layout;
		_tmp15_ = strlen (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = string_slice (_tmp12_, (glong) (_tmp13_ + 1), (glong) _tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_strconcat (_tmp11_, _tmp18_, NULL);
		_tmp20_ = layout;
		_tmp21_ = left_bracket;
		_tmp22_ = right_bracket;
		_tmp23_ = string_slice (_tmp20_, (glong) (_tmp21_ + 1), (glong) _tmp22_);
		_tmp24_ = g_new0 (gchar*, 2 + 1);
		_tmp24_[0] = _tmp19_;
		_tmp24_[1] = _tmp23_;
		_tmp25_ = _tmp24_;
		_tmp25__length1 = 2;
		_g_free0 (_tmp18_);
		_g_free0 (_tmp11_);
		_tmp26_ = _tmp25_;
		_tmp26__length1 = _tmp25__length1;
		if (result_length1) {
			*result_length1 = _tmp26__length1;
		}
		result = _tmp26_;
		return result;
	}
	_tmp27_ = layout;
	_tmp28_ = g_strdup (_tmp27_);
	_tmp29_ = g_strdup ("default");
	_tmp30_ = g_new0 (gchar*, 2 + 1);
	_tmp30_[0] = _tmp28_;
	_tmp30_[1] = _tmp29_;
	_tmp31_ = _tmp30_;
	_tmp31__length1 = 2;
	if (result_length1) {
		*result_length1 = _tmp31__length1;
	}
	result = _tmp31_;
	return result;
}


gchar* xkb_layout_get_layout (XKBLayout* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = xkb_layout_get_output_from_cmdline (self, "-query", "layout: ");
	result = _tmp0_;
	return result;
}


gchar* xkb_layout_get_variant (XKBLayout* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = xkb_layout_get_output_from_cmdline (self, "-query", "variant: ");
	result = _tmp0_;
	return result;
}


gchar* xkb_layout_get_option (XKBLayout* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = xkb_layout_get_output_from_cmdline (self, "-query", "options: ");
	result = _tmp0_;
	return result;
}


static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static void _vala_array_add40 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add41 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add42 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add43 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add44 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add45 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add46 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add47 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _xkb_layout_set_layout_cb_gchild_watch_func (GPid pid, gint status, gpointer self) {
	xkb_layout_set_layout_cb ((XKBLayout*) self, pid, status);
}


gint* xkb_layout_set_layout (XKBLayout* self, IBusEngineDesc* engine, gboolean use_group_layout, int* result_length1) {
	gint* result = NULL;
	gchar* layout = NULL;
	IBusEngineDesc* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* variant = NULL;
	IBusEngineDesc* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* option = NULL;
	IBusEngineDesc* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gint xkb_group_id = 0;
	gint changed_option = 0;
	GPid _tmp10_ = 0;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	const gchar* _tmp15_ = NULL;
	gboolean need_us_layout = FALSE;
	gchar** _tmp24_ = NULL;
	gint _tmp24__length1 = 0;
	gint layouts_max_length = 0;
	gboolean _tmp37_ = FALSE;
	const gchar* _tmp39_ = NULL;
	const gchar* _tmp41_ = NULL;
	const gchar* _tmp43_ = NULL;
	const gchar* _tmp45_ = NULL;
	const gchar* _tmp67_ = NULL;
	gboolean _tmp70_ = FALSE;
	const gchar* _tmp71_ = NULL;
	gboolean _tmp73_ = FALSE;
	const gchar* _tmp74_ = NULL;
	const gchar* _tmp89_ = NULL;
	gboolean _tmp90_ = FALSE;
	gchar** args = NULL;
	gchar** _tmp96_ = NULL;
	gint args_length1 = 0;
	gint _args_size_ = 0;
	gchar** _tmp97_ = NULL;
	gint _tmp97__length1 = 0;
	const gchar* _tmp98_ = NULL;
	gchar* _tmp99_ = NULL;
	gchar** _tmp100_ = NULL;
	gint _tmp100__length1 = 0;
	gchar* _tmp101_ = NULL;
	gchar** _tmp102_ = NULL;
	gint _tmp102__length1 = 0;
	const gchar* _tmp103_ = NULL;
	gchar* _tmp104_ = NULL;
	const gchar* _tmp105_ = NULL;
	const gchar* _tmp111_ = NULL;
	GPid child_pid = 0;
	GPid _tmp126_ = 0;
	GPid _tmp127_ = 0;
	gint _tmp128_ = 0;
	gint _tmp129_ = 0;
	gint* _tmp130_ = NULL;
	gint* _tmp131_ = NULL;
	gint _tmp131__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (engine != NULL, NULL);
	_tmp0_ = engine;
	_tmp1_ = ibus_engine_desc_get_layout (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	layout = _tmp2_;
	_tmp3_ = engine;
	_tmp4_ = ibus_engine_desc_get_layout_variant (_tmp3_);
	_tmp5_ = g_strdup (_tmp4_);
	variant = _tmp5_;
	_tmp6_ = engine;
	_tmp7_ = ibus_engine_desc_get_layout_option (_tmp6_);
	_tmp8_ = g_strdup (_tmp7_);
	option = _tmp8_;
	_tmp9_ = layout;
	_vala_assert (_tmp9_ != NULL, "layout != null");
	xkb_group_id = 0;
	changed_option = 0;
	_tmp10_ = self->priv->m_xkb_pid;
	if (_tmp10_ != ((GPid) (-1))) {
		gint* _tmp11_ = NULL;
		gint* _tmp12_ = NULL;
		gint _tmp12__length1 = 0;
		_tmp11_ = g_new0 (gint, 2);
		_tmp11_[0] = -1;
		_tmp11_[1] = 0;
		_tmp12_ = _tmp11_;
		_tmp12__length1 = 2;
		if (result_length1) {
			*result_length1 = _tmp12__length1;
		}
		result = _tmp12_;
		_g_free0 (option);
		_g_free0 (variant);
		_g_free0 (layout);
		return result;
	}
	_tmp15_ = layout;
	if (g_strcmp0 (_tmp15_, "default") == 0) {
		gboolean _tmp16_ = FALSE;
		const gchar* _tmp17_ = NULL;
		_tmp17_ = variant;
		if (g_strcmp0 (_tmp17_, "default") == 0) {
			_tmp16_ = TRUE;
		} else {
			const gchar* _tmp18_ = NULL;
			_tmp18_ = variant;
			_tmp16_ = g_strcmp0 (_tmp18_, "") == 0;
		}
		_tmp14_ = _tmp16_;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		gboolean _tmp19_ = FALSE;
		const gchar* _tmp20_ = NULL;
		_tmp20_ = option;
		if (g_strcmp0 (_tmp20_, "default") == 0) {
			_tmp19_ = TRUE;
		} else {
			const gchar* _tmp21_ = NULL;
			_tmp21_ = option;
			_tmp19_ = g_strcmp0 (_tmp21_, "") == 0;
		}
		_tmp13_ = _tmp19_;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		gint* _tmp22_ = NULL;
		gint* _tmp23_ = NULL;
		gint _tmp23__length1 = 0;
		_tmp22_ = g_new0 (gint, 2);
		_tmp22_[0] = -1;
		_tmp22_[1] = 0;
		_tmp23_ = _tmp22_;
		_tmp23__length1 = 2;
		if (result_length1) {
			*result_length1 = _tmp23__length1;
		}
		result = _tmp23_;
		_g_free0 (option);
		_g_free0 (variant);
		_g_free0 (layout);
		return result;
	}
	need_us_layout = FALSE;
	_tmp24_ = self->priv->m_xkb_latin_layouts;
	_tmp24__length1 = self->priv->m_xkb_latin_layouts_length1;
	{
		gchar** latin_layout_collection = NULL;
		gint latin_layout_collection_length1 = 0;
		gint _latin_layout_collection_size_ = 0;
		gint latin_layout_it = 0;
		latin_layout_collection = _tmp24_;
		latin_layout_collection_length1 = _tmp24__length1;
		for (latin_layout_it = 0; latin_layout_it < _tmp24__length1; latin_layout_it = latin_layout_it + 1) {
			gchar* _tmp25_ = NULL;
			gchar* latin_layout = NULL;
			_tmp25_ = g_strdup (latin_layout_collection[latin_layout_it]);
			latin_layout = _tmp25_;
			{
				gboolean _tmp26_ = FALSE;
				const gchar* _tmp27_ = NULL;
				const gchar* _tmp28_ = NULL;
				gboolean _tmp30_ = FALSE;
				const gchar* _tmp31_ = NULL;
				_tmp27_ = layout;
				_tmp28_ = latin_layout;
				if (g_strcmp0 (_tmp27_, _tmp28_) == 0) {
					const gchar* _tmp29_ = NULL;
					_tmp29_ = variant;
					_tmp26_ = g_strcmp0 (_tmp29_, "eng") != 0;
				} else {
					_tmp26_ = FALSE;
				}
				if (_tmp26_) {
					need_us_layout = TRUE;
					_g_free0 (latin_layout);
					break;
				}
				_tmp31_ = variant;
				if (_tmp31_ != NULL) {
					const gchar* _tmp32_ = NULL;
					const gchar* _tmp33_ = NULL;
					gchar* _tmp34_ = NULL;
					gchar* _tmp35_ = NULL;
					const gchar* _tmp36_ = NULL;
					_tmp32_ = layout;
					_tmp33_ = variant;
					_tmp34_ = g_strdup_printf ("%s(%s)", _tmp32_, _tmp33_);
					_tmp35_ = _tmp34_;
					_tmp36_ = latin_layout;
					_tmp30_ = g_strcmp0 (_tmp35_, _tmp36_) == 0;
					_g_free0 (_tmp35_);
				} else {
					_tmp30_ = FALSE;
				}
				if (_tmp30_) {
					need_us_layout = TRUE;
					_g_free0 (latin_layout);
					break;
				}
				_g_free0 (latin_layout);
			}
		}
	}
	layouts_max_length = XKB_LAYOUTS_MAX_LENGTH;
	_tmp37_ = need_us_layout;
	if (_tmp37_) {
		gint _tmp38_ = 0;
		_tmp38_ = layouts_max_length;
		layouts_max_length = _tmp38_ - 1;
	}
	_tmp39_ = self->priv->m_default_layout;
	if (g_strcmp0 (_tmp39_, "") == 0) {
		gchar* _tmp40_ = NULL;
		_tmp40_ = xkb_layout_get_layout (self);
		_g_free0 (self->priv->m_default_layout);
		self->priv->m_default_layout = _tmp40_;
	}
	_tmp41_ = self->priv->m_default_variant;
	if (g_strcmp0 (_tmp41_, "") == 0) {
		gchar* _tmp42_ = NULL;
		_tmp42_ = xkb_layout_get_variant (self);
		_g_free0 (self->priv->m_default_variant);
		self->priv->m_default_variant = _tmp42_;
	}
	_tmp43_ = self->priv->m_default_option;
	if (g_strcmp0 (_tmp43_, "") == 0) {
		gchar* _tmp44_ = NULL;
		_tmp44_ = xkb_layout_get_option (self);
		_g_free0 (self->priv->m_default_option);
		self->priv->m_default_option = _tmp44_;
	}
	_tmp45_ = layout;
	if (g_strcmp0 (_tmp45_, "default") == 0) {
		const gchar* _tmp46_ = NULL;
		gchar* _tmp47_ = NULL;
		const gchar* _tmp48_ = NULL;
		gchar* _tmp49_ = NULL;
		_tmp46_ = self->priv->m_default_layout;
		_tmp47_ = g_strdup (_tmp46_);
		_g_free0 (layout);
		layout = _tmp47_;
		_tmp48_ = self->priv->m_default_variant;
		_tmp49_ = g_strdup (_tmp48_);
		_g_free0 (variant);
		variant = _tmp49_;
	} else {
		gboolean _tmp50_ = FALSE;
		_tmp50_ = use_group_layout;
		if (_tmp50_) {
			const gchar* _tmp51_ = NULL;
			gchar** retval = NULL;
			const gchar* _tmp53_ = NULL;
			const gchar* _tmp54_ = NULL;
			gint _tmp55_ = 0;
			gint _tmp56_ = 0;
			gchar** _tmp57_ = NULL;
			gint retval_length1 = 0;
			gint _retval_size_ = 0;
			gchar** _tmp58_ = NULL;
			gint _tmp58__length1 = 0;
			const gchar* _tmp59_ = NULL;
			gchar* _tmp60_ = NULL;
			gchar** _tmp61_ = NULL;
			gint _tmp61__length1 = 0;
			const gchar* _tmp62_ = NULL;
			gchar* _tmp63_ = NULL;
			gchar** _tmp64_ = NULL;
			gint _tmp64__length1 = 0;
			const gchar* _tmp65_ = NULL;
			gint _tmp66_ = 0;
			_tmp51_ = variant;
			if (g_strcmp0 (_tmp51_, "default") == 0) {
				gchar* _tmp52_ = NULL;
				_tmp52_ = g_strdup ("");
				_g_free0 (variant);
				variant = _tmp52_;
			}
			_tmp53_ = layout;
			_tmp54_ = variant;
			_tmp55_ = layouts_max_length;
			_tmp57_ = xkb_layout_get_xkb_group_layout (self, _tmp53_, _tmp54_, _tmp55_, &_tmp56_);
			retval = _tmp57_;
			retval_length1 = _tmp56_;
			_retval_size_ = retval_length1;
			_tmp58_ = retval;
			_tmp58__length1 = retval_length1;
			_tmp59_ = _tmp58_[0];
			_tmp60_ = g_strdup (_tmp59_);
			_g_free0 (layout);
			layout = _tmp60_;
			_tmp61_ = retval;
			_tmp61__length1 = retval_length1;
			_tmp62_ = _tmp61_[1];
			_tmp63_ = g_strdup (_tmp62_);
			_g_free0 (variant);
			variant = _tmp63_;
			_tmp64_ = retval;
			_tmp64__length1 = retval_length1;
			_tmp65_ = _tmp64_[2];
			_tmp66_ = atoi (_tmp65_);
			xkb_group_id = _tmp66_;
			retval = (_vala_array_free (retval, retval_length1, (GDestroyNotify) g_free), NULL);
		}
	}
	_tmp67_ = layout;
	if (g_strcmp0 (_tmp67_, "") == 0) {
		gint* _tmp68_ = NULL;
		gint* _tmp69_ = NULL;
		gint _tmp69__length1 = 0;
		g_warning ("xkblayout.vala:300: Could not get the correct layout");
		_tmp68_ = g_new0 (gint, 2);
		_tmp68_[0] = -1;
		_tmp68_[1] = 0;
		_tmp69_ = _tmp68_;
		_tmp69__length1 = 2;
		if (result_length1) {
			*result_length1 = _tmp69__length1;
		}
		result = _tmp69_;
		_g_free0 (option);
		_g_free0 (variant);
		_g_free0 (layout);
		return result;
	}
	_tmp71_ = variant;
	if (g_strcmp0 (_tmp71_, "default") == 0) {
		_tmp70_ = TRUE;
	} else {
		const gchar* _tmp72_ = NULL;
		_tmp72_ = variant;
		_tmp70_ = g_strcmp0 (_tmp72_, "") == 0;
	}
	if (_tmp70_) {
		_g_free0 (variant);
		variant = NULL;
	}
	_tmp74_ = option;
	if (g_strcmp0 (_tmp74_, "default") == 0) {
		_tmp73_ = TRUE;
	} else {
		const gchar* _tmp75_ = NULL;
		_tmp75_ = option;
		_tmp73_ = g_strcmp0 (_tmp75_, "") == 0;
	}
	if (_tmp73_) {
		const gchar* _tmp76_ = NULL;
		gchar* _tmp77_ = NULL;
		_tmp76_ = self->priv->m_default_option;
		_tmp77_ = g_strdup (_tmp76_);
		_g_free0 (option);
		option = _tmp77_;
	} else {
		const gchar* _tmp78_ = NULL;
		const gchar* _tmp79_ = NULL;
		gchar** _tmp80_ = NULL;
		gchar** _tmp81_ = NULL;
		gchar** _tmp82_ = NULL;
		gint _tmp82__length1 = 0;
		gboolean _tmp83_ = FALSE;
		_tmp78_ = option;
		_tmp79_ = self->priv->m_default_option;
		_tmp81_ = _tmp80_ = g_strsplit (_tmp79_, ",", 0);
		_tmp82_ = _tmp81_;
		_tmp82__length1 = _vala_array_length (_tmp80_);
		_tmp83_ = !_vala_string_array_contains (_tmp82_, _vala_array_length (_tmp80_), _tmp78_);
		_tmp82_ = (_vala_array_free (_tmp82_, _tmp82__length1, (GDestroyNotify) g_free), NULL);
		if (_tmp83_) {
			const gchar* _tmp84_ = NULL;
			const gchar* _tmp85_ = NULL;
			gchar* _tmp86_ = NULL;
			_tmp84_ = self->priv->m_default_option;
			_tmp85_ = option;
			_tmp86_ = g_strdup_printf ("%s,%s", _tmp84_, _tmp85_);
			_g_free0 (option);
			option = _tmp86_;
			changed_option = 1;
		} else {
			const gchar* _tmp87_ = NULL;
			gchar* _tmp88_ = NULL;
			_tmp87_ = self->priv->m_default_option;
			_tmp88_ = g_strdup (_tmp87_);
			_g_free0 (option);
			option = _tmp88_;
		}
	}
	_tmp89_ = option;
	if (g_strcmp0 (_tmp89_, "") == 0) {
		_g_free0 (option);
		option = NULL;
	}
	_tmp90_ = need_us_layout;
	if (_tmp90_) {
		const gchar* _tmp91_ = NULL;
		gchar* _tmp92_ = NULL;
		const gchar* _tmp93_ = NULL;
		_tmp91_ = layout;
		_tmp92_ = g_strconcat (_tmp91_, ",us", NULL);
		_g_free0 (layout);
		layout = _tmp92_;
		_tmp93_ = variant;
		if (_tmp93_ != NULL) {
			const gchar* _tmp94_ = NULL;
			gchar* _tmp95_ = NULL;
			_tmp94_ = variant;
			_tmp95_ = g_strconcat (_tmp94_, ",", NULL);
			_g_free0 (variant);
			variant = _tmp95_;
		}
	}
	_tmp96_ = g_new0 (gchar*, 0 + 1);
	args = _tmp96_;
	args_length1 = 0;
	_args_size_ = args_length1;
	_tmp97_ = args;
	_tmp97__length1 = args_length1;
	_tmp98_ = self->priv->m_xkb_command;
	_tmp99_ = g_strdup (_tmp98_);
	_vala_array_add40 (&args, &args_length1, &_args_size_, _tmp99_);
	_tmp100_ = args;
	_tmp100__length1 = args_length1;
	_tmp101_ = g_strdup ("-layout");
	_vala_array_add41 (&args, &args_length1, &_args_size_, _tmp101_);
	_tmp102_ = args;
	_tmp102__length1 = args_length1;
	_tmp103_ = layout;
	_tmp104_ = g_strdup (_tmp103_);
	_vala_array_add42 (&args, &args_length1, &_args_size_, _tmp104_);
	_tmp105_ = variant;
	if (_tmp105_ != NULL) {
		gchar** _tmp106_ = NULL;
		gint _tmp106__length1 = 0;
		gchar* _tmp107_ = NULL;
		gchar** _tmp108_ = NULL;
		gint _tmp108__length1 = 0;
		const gchar* _tmp109_ = NULL;
		gchar* _tmp110_ = NULL;
		_tmp106_ = args;
		_tmp106__length1 = args_length1;
		_tmp107_ = g_strdup ("-variant");
		_vala_array_add43 (&args, &args_length1, &_args_size_, _tmp107_);
		_tmp108_ = args;
		_tmp108__length1 = args_length1;
		_tmp109_ = variant;
		_tmp110_ = g_strdup (_tmp109_);
		_vala_array_add44 (&args, &args_length1, &_args_size_, _tmp110_);
	}
	_tmp111_ = option;
	if (_tmp111_ != NULL) {
		gchar** _tmp112_ = NULL;
		gint _tmp112__length1 = 0;
		gchar* _tmp113_ = NULL;
		gchar** _tmp114_ = NULL;
		gint _tmp114__length1 = 0;
		gchar* _tmp115_ = NULL;
		gchar** _tmp116_ = NULL;
		gint _tmp116__length1 = 0;
		const gchar* _tmp117_ = NULL;
		gchar* _tmp118_ = NULL;
		_tmp112_ = args;
		_tmp112__length1 = args_length1;
		_tmp113_ = g_strdup ("-option");
		_vala_array_add45 (&args, &args_length1, &_args_size_, _tmp113_);
		_tmp114_ = args;
		_tmp114__length1 = args_length1;
		_tmp115_ = g_strdup ("-option");
		_vala_array_add46 (&args, &args_length1, &_args_size_, _tmp115_);
		_tmp116_ = args;
		_tmp116__length1 = args_length1;
		_tmp117_ = option;
		_tmp118_ = g_strdup (_tmp117_);
		_vala_array_add47 (&args, &args_length1, &_args_size_, _tmp118_);
	}
	{
		gchar** _tmp119_ = NULL;
		gint _tmp119__length1 = 0;
		GPid _tmp120_ = 0;
		_tmp119_ = args;
		_tmp119__length1 = args_length1;
		g_spawn_async (NULL, _tmp119_, NULL, G_SPAWN_DO_NOT_REAP_CHILD | G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp120_, &_inner_error_);
		child_pid = _tmp120_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_SPAWN_ERROR) {
				goto __catch7_g_spawn_error;
			}
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (option);
			_g_free0 (variant);
			_g_free0 (layout);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	goto __finally7;
	__catch7_g_spawn_error:
	{
		GError* err = NULL;
		FILE* _tmp121_ = NULL;
		GError* _tmp122_ = NULL;
		const gchar* _tmp123_ = NULL;
		gint* _tmp124_ = NULL;
		gint* _tmp125_ = NULL;
		gint _tmp125__length1 = 0;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp121_ = stderr;
		_tmp122_ = err;
		_tmp123_ = _tmp122_->message;
		fprintf (_tmp121_, "Execute setxkbmap failed: %s\n", _tmp123_);
		_tmp124_ = g_new0 (gint, 2);
		_tmp124_[0] = -1;
		_tmp124_[1] = 0;
		_tmp125_ = _tmp124_;
		_tmp125__length1 = 2;
		if (result_length1) {
			*result_length1 = _tmp125__length1;
		}
		result = _tmp125_;
		_g_error_free0 (err);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (option);
		_g_free0 (variant);
		_g_free0 (layout);
		return result;
	}
	__finally7:
	if (_inner_error_ != NULL) {
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (option);
		_g_free0 (variant);
		_g_free0 (layout);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp126_ = child_pid;
	self->priv->m_xkb_pid = _tmp126_;
	_tmp127_ = self->priv->m_xkb_pid;
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp127_, _xkb_layout_set_layout_cb_gchild_watch_func, xkb_layout_ref (self), xkb_layout_unref);
	_tmp128_ = xkb_group_id;
	_tmp129_ = changed_option;
	_tmp130_ = g_new0 (gint, 2);
	_tmp130_[0] = _tmp128_;
	_tmp130_[1] = _tmp129_;
	_tmp131_ = _tmp130_;
	_tmp131__length1 = 2;
	if (result_length1) {
		*result_length1 = _tmp131__length1;
	}
	result = _tmp131_;
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (option);
	_g_free0 (variant);
	_g_free0 (layout);
	return result;
}


static void _xkb_layout_set_xmodmap_cb_gchild_watch_func (GPid pid, gint status, gpointer self) {
	xkb_layout_set_xmodmap_cb ((XKBLayout*) self, pid, status);
}


void xkb_layout_set_xmodmap (XKBLayout* self) {
	gboolean _tmp0_ = FALSE;
	GPid _tmp1_ = 0;
	gchar* xmodmap_cmdpath = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* homedir = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar** _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_use_xmodmap;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->m_xmodmap_pid;
	if (_tmp1_ != ((GPid) (-1))) {
		return;
	}
	_tmp2_ = self->priv->m_xmodmap_command;
	_tmp3_ = xkb_layout_get_fullpath (self, _tmp2_);
	xmodmap_cmdpath = _tmp3_;
	_tmp4_ = xmodmap_cmdpath;
	if (g_strcmp0 (_tmp4_, "") == 0) {
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = self->priv->m_xmodmap_command;
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (xmodmap_cmdpath);
		xmodmap_cmdpath = _tmp6_;
	}
	_tmp7_ = g_get_home_dir ();
	_tmp8_ = g_strdup (_tmp7_);
	homedir = _tmp8_;
	_tmp9_ = self->priv->m_xmodmap_known_files;
	_tmp9__length1 = self->priv->m_xmodmap_known_files_length1;
	{
		gchar** xmodmap_file_collection = NULL;
		gint xmodmap_file_collection_length1 = 0;
		gint _xmodmap_file_collection_size_ = 0;
		gint xmodmap_file_it = 0;
		xmodmap_file_collection = _tmp9_;
		xmodmap_file_collection_length1 = _tmp9__length1;
		for (xmodmap_file_it = 0; xmodmap_file_it < _tmp9__length1; xmodmap_file_it = xmodmap_file_it + 1) {
			gchar* _tmp10_ = NULL;
			gchar* xmodmap_file = NULL;
			_tmp10_ = g_strdup (xmodmap_file_collection[xmodmap_file_it]);
			xmodmap_file = _tmp10_;
			{
				gchar* xmodmap_filepath = NULL;
				const gchar* _tmp11_ = NULL;
				const gchar* _tmp12_ = NULL;
				gchar* _tmp13_ = NULL;
				const gchar* _tmp14_ = NULL;
				gboolean _tmp15_ = FALSE;
				gchar** args = NULL;
				const gchar* _tmp16_ = NULL;
				gchar* _tmp17_ = NULL;
				const gchar* _tmp18_ = NULL;
				gchar* _tmp19_ = NULL;
				gchar** _tmp20_ = NULL;
				gint args_length1 = 0;
				gint _args_size_ = 0;
				GPid child_pid = 0;
				GPid _tmp26_ = 0;
				GPid _tmp27_ = 0;
				_tmp11_ = homedir;
				_tmp12_ = xmodmap_file;
				_tmp13_ = g_build_filename (_tmp11_, _tmp12_, NULL);
				xmodmap_filepath = _tmp13_;
				_tmp14_ = xmodmap_filepath;
				_tmp15_ = g_file_test (_tmp14_, G_FILE_TEST_EXISTS);
				if (!_tmp15_) {
					_g_free0 (xmodmap_filepath);
					_g_free0 (xmodmap_file);
					continue;
				}
				_tmp16_ = xmodmap_cmdpath;
				_tmp17_ = g_strdup (_tmp16_);
				_tmp18_ = xmodmap_filepath;
				_tmp19_ = g_strdup (_tmp18_);
				_tmp20_ = g_new0 (gchar*, 2 + 1);
				_tmp20_[0] = _tmp17_;
				_tmp20_[1] = _tmp19_;
				args = _tmp20_;
				args_length1 = 2;
				_args_size_ = args_length1;
				{
					gchar** _tmp21_ = NULL;
					gint _tmp21__length1 = 0;
					GPid _tmp22_ = 0;
					_tmp21_ = args;
					_tmp21__length1 = args_length1;
					g_spawn_async (NULL, _tmp21_, NULL, G_SPAWN_DO_NOT_REAP_CHILD | G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp22_, &_inner_error_);
					child_pid = _tmp22_;
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == G_SPAWN_ERROR) {
							goto __catch8_g_spawn_error;
						}
						args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (xmodmap_filepath);
						_g_free0 (xmodmap_file);
						_g_free0 (homedir);
						_g_free0 (xmodmap_cmdpath);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
				goto __finally8;
				__catch8_g_spawn_error:
				{
					GError* err = NULL;
					FILE* _tmp23_ = NULL;
					GError* _tmp24_ = NULL;
					const gchar* _tmp25_ = NULL;
					err = _inner_error_;
					_inner_error_ = NULL;
					_tmp23_ = stderr;
					_tmp24_ = err;
					_tmp25_ = _tmp24_->message;
					fprintf (_tmp23_, "IBUS_ERROR: %s\n", _tmp25_);
					_g_error_free0 (err);
					args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (xmodmap_filepath);
					_g_free0 (xmodmap_file);
					_g_free0 (homedir);
					_g_free0 (xmodmap_cmdpath);
					return;
				}
				__finally8:
				if (_inner_error_ != NULL) {
					args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (xmodmap_filepath);
					_g_free0 (xmodmap_file);
					_g_free0 (homedir);
					_g_free0 (xmodmap_cmdpath);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_tmp26_ = child_pid;
				self->priv->m_xmodmap_pid = _tmp26_;
				_tmp27_ = self->priv->m_xmodmap_pid;
				g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp27_, _xkb_layout_set_xmodmap_cb_gchild_watch_func, xkb_layout_ref (self), xkb_layout_unref);
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (xmodmap_filepath);
				_g_free0 (xmodmap_file);
				break;
			}
		}
	}
	_g_free0 (homedir);
	_g_free0 (xmodmap_cmdpath);
}


void xkb_layout_reset_layout (XKBLayout* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = xkb_layout_get_layout (self);
	_g_free0 (self->priv->m_default_layout);
	self->priv->m_default_layout = _tmp0_;
	_tmp1_ = xkb_layout_get_variant (self);
	_g_free0 (self->priv->m_default_variant);
	self->priv->m_default_variant = _tmp1_;
	_tmp2_ = xkb_layout_get_option (self);
	_g_free0 (self->priv->m_default_option);
	self->priv->m_default_option = _tmp2_;
}


static void value_xkb_layout_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_xkb_layout_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		xkb_layout_unref (value->data[0].v_pointer);
	}
}


static void value_xkb_layout_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = xkb_layout_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_xkb_layout_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_xkb_layout_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		XKBLayout* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = xkb_layout_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_xkb_layout_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	XKBLayout** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = xkb_layout_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_xkb_layout (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecXKBLayout* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_XKB_LAYOUT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_xkb_layout (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_XKB_LAYOUT), NULL);
	return value->data[0].v_pointer;
}


void value_set_xkb_layout (GValue* value, gpointer v_object) {
	XKBLayout* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_XKB_LAYOUT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_XKB_LAYOUT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		xkb_layout_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xkb_layout_unref (old);
	}
}


void value_take_xkb_layout (GValue* value, gpointer v_object) {
	XKBLayout* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_XKB_LAYOUT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_XKB_LAYOUT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xkb_layout_unref (old);
	}
}


static void xkb_layout_class_init (XKBLayoutClass * klass) {
	xkb_layout_parent_class = g_type_class_peek_parent (klass);
	XKB_LAYOUT_CLASS (klass)->finalize = xkb_layout_finalize;
	g_type_class_add_private (klass, sizeof (XKBLayoutPrivate));
}


static void xkb_layout_instance_init (XKBLayout * self) {
	gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar** _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	self->priv = XKB_LAYOUT_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("setxkbmap");
	self->priv->m_xkb_command = _tmp0_;
	_tmp1_ = g_new0 (gchar*, 0 + 1);
	self->priv->m_xkb_latin_layouts = _tmp1_;
	self->priv->m_xkb_latin_layouts_length1 = 0;
	self->priv->_m_xkb_latin_layouts_size_ = self->priv->m_xkb_latin_layouts_length1;
	self->priv->m_xkb_pid = (GPid) (-1);
	self->priv->m_xmodmap_pid = (GPid) (-1);
	_tmp2_ = g_strdup ("xmodmap");
	self->priv->m_xmodmap_command = _tmp2_;
	self->priv->m_use_xmodmap = TRUE;
	_tmp3_ = g_strdup (".xmodmap");
	_tmp4_ = g_strdup (".xmodmaprc");
	_tmp5_ = g_strdup (".Xmodmap");
	_tmp6_ = g_strdup (".Xmodmaprc");
	_tmp7_ = g_new0 (gchar*, 4 + 1);
	_tmp7_[0] = _tmp3_;
	_tmp7_[1] = _tmp4_;
	_tmp7_[2] = _tmp5_;
	_tmp7_[3] = _tmp6_;
	self->priv->m_xmodmap_known_files = _tmp7_;
	self->priv->m_xmodmap_known_files_length1 = 4;
	self->priv->_m_xmodmap_known_files_size_ = self->priv->m_xmodmap_known_files_length1;
	_tmp8_ = g_strdup ("");
	self->priv->m_default_layout = _tmp8_;
	_tmp9_ = g_strdup ("");
	self->priv->m_default_variant = _tmp9_;
	_tmp10_ = g_strdup ("");
	self->priv->m_default_option = _tmp10_;
	self->ref_count = 1;
}


static void xkb_layout_finalize (XKBLayout* obj) {
	XKBLayout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_XKB_LAYOUT, XKBLayout);
	_g_free0 (self->priv->m_xkb_command);
	_g_object_unref0 (self->priv->m_settings_general);
	self->priv->m_xkb_latin_layouts = (_vala_array_free (self->priv->m_xkb_latin_layouts, self->priv->m_xkb_latin_layouts_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->m_xmodmap_command);
	self->priv->m_xmodmap_known_files = (_vala_array_free (self->priv->m_xmodmap_known_files, self->priv->m_xmodmap_known_files_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->m_default_layout);
	_g_free0 (self->priv->m_default_variant);
	_g_free0 (self->priv->m_default_option);
}


GType xkb_layout_get_type (void) {
	static volatile gsize xkb_layout_type_id__volatile = 0;
	if (g_once_init_enter (&xkb_layout_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_xkb_layout_init, value_xkb_layout_free_value, value_xkb_layout_copy_value, value_xkb_layout_peek_pointer, "p", value_xkb_layout_collect_value, "p", value_xkb_layout_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (XKBLayoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xkb_layout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XKBLayout), 0, (GInstanceInitFunc) xkb_layout_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType xkb_layout_type_id;
		xkb_layout_type_id = g_type_register_fundamental (g_type_fundamental_next (), "XKBLayout", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&xkb_layout_type_id__volatile, xkb_layout_type_id);
	}
	return xkb_layout_type_id__volatile;
}


gpointer xkb_layout_ref (gpointer instance) {
	XKBLayout* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void xkb_layout_unref (gpointer instance) {
	XKBLayout* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		XKB_LAYOUT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



